
//COLOR LIBRARIES 
//RGB to HSL 
struct hsl_color
{
double hue,saturation,lightness;
hsl_color(void){hue=0;saturation=0;lightness=0;}
};
hsl_color RGBtoHSL(int r,int g,int b)
{
hsl_color returnio;
  //a.turn to 0->1 zo=zero to one
    double zo_red=((double)r)/255;
    double zo_gre=((double)g)/255;
    double zo_blu=((double)b)/255;
  //b.min and max
    double zo_max=MathMax(zo_red,zo_gre);
           zo_max=MathMax(zo_max,zo_blu);
    double zo_min=MathMin(zo_red,zo_gre);
           zo_min=MathMin(zo_min,zo_blu);
   //c.luminance (% if x 100)
     returnio.lightness=(zo_max+zo_min)/2;
   //d.saturation (% if x 100)
    if(zo_min!=zo_max)
     {
     if(returnio.lightness<0.5) returnio.saturation=(zo_max-zo_min)/(zo_max+zo_min);
     if(returnio.lightness>=0.5) returnio.saturation=(zo_max-zo_min)/(2.0-zo_max-zo_min);
     }
   //e.hue degrees
    if(zo_min!=zo_max)
     {
     //if red is max
       if(zo_red==zo_max) returnio.hue=(zo_gre-zo_blu)/(zo_max-zo_min);
       if(zo_gre==zo_max) returnio.hue=2.0+((zo_blu-zo_red)/(zo_max-zo_min));
       if(zo_blu==zo_max) returnio.hue=4.0+((zo_red-zo_gre)/(zo_max-zo_min));
       returnio.hue=returnio.hue*60;
       if(returnio.hue>360) returnio.hue=returnio.hue-360;
       if(returnio.hue<0) returnio.hue=returnio.hue+360;
     }
return(returnio);
}
//RGB TO HSL ENDS HERE 

//HSL TO RGB 
struct rgb_color
{
int r,g,b;
rgb_color(void){r=0;g=0;b=0;}
};
rgb_color HSLtoRGB(double h,double s,double l)
{
rgb_color returnio;
  //if there is no saturation 
  if(s==0)
  {
  returnio.r=(int)(l*255);
  returnio.g=(int)(l*255);
  returnio.b=(int)(l*255);
  if(returnio.r<0) returnio.r=0;
  if(returnio.g<0) returnio.g=0;
  if(returnio.b<0) returnio.b=0;
  if(returnio.r>255) returnio.r=255;
  if(returnio.g>255) returnio.g=255;
  if(returnio.b>255) returnio.b=255;
  }
  //if there is no saturation ends here 
  //if saturation exists 
  if(s>0)
  {
  double temp_1=0;
  if(l<0.5) temp_1=l*(1.0+s);
  if(l>=0.5) temp_1=l+s-(l*s);
  double temp_2=2*l-temp_1;
  h=h/360;
  double temp_r=h+0.333;
  if(temp_r>1) temp_r=temp_r-1;
  double temp_g=h;
  double temp_b=h-0.333;
  if(temp_b<0) temp_b=temp_b+1;
  double new_r=0,new_g=0,new_b=0;
  //prep red channel 
    new_r=temp_2;
    //test c
    if((2*temp_r)>1&&(3*temp_r)<=2) new_r=temp_2+(temp_1-temp_2)*(0.666-temp_r)*6;
    //test b
    if((2*temp_r)<=1) new_r=temp_1;
    //test a 
    if((6*temp_r)<=1) new_r=temp_2+(temp_1-temp_2)*6*temp_r;
    //new r is 0->1 turn 0->255
    new_r=new_r*255;
    if(new_r<0) new_r=0;
    if(new_r>255) new_r=255;
    returnio.r=(int)new_r;
  //prep green channel 
    new_g=temp_2;
    //test c
    if((2*temp_g)>1&&(3*temp_g)<=2) new_g=temp_2+(temp_1-temp_2)*(0.666-temp_g)*6;
    //test b
    if((2*temp_g)<=1) new_g=temp_1;
    //test a 
    if((6*temp_g)<=1) new_g=temp_2+(temp_1-temp_2)*6*temp_g;
    //new g is 0->1 turn 0->255
    new_g=new_g*255;
    if(new_g<0) new_g=0;
    if(new_g>255) new_g=255;
    returnio.g=(int)new_g;
  //prep blue channel 
    new_b=temp_2;
    //test c
    if((2*temp_b)>1&&(3*temp_b)<=2) new_b=temp_2+(temp_1-temp_2)*(0.666-temp_b)*6;
    //test b
    if((2*temp_b)<=1) new_b=temp_1;
    //test a 
    if((6*temp_b)<=1) new_b=temp_2+(temp_1-temp_2)*6*temp_b;
    //new r is 0->1 turn 0->255
    new_b=new_b*255;
    if(new_b<0) new_b=0;
    if(new_b>255) new_b=255;
    returnio.b=(int)new_b;     
  }
  //if saturation exists ends here 
return(returnio);
}
//HSL TO RGB ENDS HERE 

//OPPOSITE COLOR WITH HSL
hsl_color HSLOpposite(double h,double s,double l,double degrees=180.0)
{
hsl_color returnio;
returnio.hue=h-(degrees*s);//by saturation , in other words , the more saturation the more hue adjusts
returnio.saturation=s;
returnio.lightness=(l*s)+((1-l)*(1-s));
return(returnio);
}
//OPPOSITE COLOR WITH HSL ENDS HERE 

//OPPOSITE COLOR WITH RGB
rgb_color RGBOpposite(int r,int g,int b,double degrees=180.0)
{
rgb_color returnio;
hsl_color tohsl=RGBtoHSL(r,g,b);
tohsl=HSLOpposite(tohsl.hue,tohsl.saturation,tohsl.lightness,degrees);
returnio=HSLtoRGB(tohsl.hue,tohsl.saturation,tohsl.lightness);
return(returnio);
}
//OPPOSITE COLOR WITH RGB ENDS HERE 

//OPPOSITE COLOR WITH COLOR
color OppositeOf(color _this,double degrees=180.0){
uint full=ColorToARGB(_this,255);
int red=(int)((full<<8)>>24);
int green=(int)((full<<16)>>24);
int blue=(int)((full<<24)>>24);
rgb_color result=RGBOpposite(red,green,blue,degrees);
string str=IntegerToString(result.r)+","+IntegerToString(result.g)+","+IntegerToString(result.b);
return(StringToColor(str));
}